-------------------------------------------------------------------
--           RAPID - RAPID ADA PORTABLE INTERFACE DESIGNER         
--           MCC GUI PACKAGE LIBRARY                               
--           Copyright (C) 1999 Martin C. Carlisle.                
--                                                                 
-- RAPID is free software;  you can  redistribute it  and/or modify
-- it under terms of the  GNU General Public License as published  
-- by the Free Software  Foundation;  either version 2,  or (at your
-- option) any later version.  RAPID is distributed in the hope that 
-- it will be useful, but WITHOUT ANY WARRANTY;  without even the 
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
-- PURPOSE.  See the GNU General Public License for more details.  
-- You should have  received  a copy of the GNU General Public License
-- distributed with RAPID; see file COPYING.  If not, write to the 
-- Free Software Foundation,  59 Temple Place - Suite 330,  Boston, 
-- MA 02111-1307, USA.                                                 
--                                                                     
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an 
-- executable, this unit does not by itself cause the resulting 
-- executable to be covered by the GNU General Public License.  
-- This exception does not however invalidate any other reasons 
-- why the executable file might be covered by the GNU Public 
-- License.  This exception does not apply to executables which
-- are GUI design tools, or that could act as a replacement
-- for RAPID.
------------------------------------------------------------------------------
with MSSyst.Drawing;
use MSSyst.Drawing;
with MSSyst.Drawing.Color;
with MSSyst.Windows.Forms;
use MSSyst.Windows.Forms;
with MSSyst.Windows.Forms.Control;
with MSSyst.Windows.Forms.Tooltip;
with MSSyst.String;
use MSSyst.String;
package body Mcc.Gui.Widget is

   ----------------
   -- Get_Parent --
   ----------------

   function Get_Parent
     (Obj : in Widget'Class)
      return Mcc.Gui.Container.Container_Pointer
   is
   begin
      return Obj.Parent;
   end Get_Parent;

   --------------------------
   -- Set_Foreground_Color --
   --------------------------

   procedure Set_Foreground_Color
     (Obj       : in out Widget;
      New_Color : in     Color)
   is
      The_Peer : Control.Ref := Control.Ref (Get_Peer(Obj)); 
      Msil_Color : MSSyst.Drawing.Color.Valuetype;       
   begin
      Msil_Color := MSSyst.Drawing.Color.FromArgb(
         Integer(New_Color.Red),
         Integer(New_Color.Green),
         Integer(New_Color.Blue));
      The_Peer.set_ForeColor(Msil_Color);
   end Set_Foreground_Color;

   ----------------------
   -- Set_Tooltip_Text --
   ----------------------

   procedure Set_Tooltip_Text
     (Obj  : in out Widget;
      Text : in String)
   is
      Container : Mcc.Gui.Container.Container_Pointer := Get_Parent(Obj);
      The_Peer : Control.Ref := Control.Ref (Get_Peer(Obj)); 
      The_Tooltip : Tooltip.Ref;
   begin
      The_Tooltip := Tooltip.New_Tooltip;
      The_Tooltip.SetTooltip(The_Peer,Text);
   end Set_Tooltip_Text;

   -----------
   -- focus --
   -----------
   
   procedure focus (obj : in widget) is
      The_Peer : Control.Ref := Control.Ref (Get_Peer(Obj));
      Dummy : Boolean;
   begin
      Dummy := The_Peer.Focus;
   end focus;

end Mcc.Gui.Widget;

